import request from '~/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {CmsProductComment, CmsProductCommentParam} from './model';


/**
 * 分页查询产品评论
 */
export async function pageCmsProductComment(params: CmsProductCommentParam) {
  const res = await request.get<ApiResult<PageResult<CmsProductComment>>>(
    '/cms/cms-product-comment/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询产品评论列表
 */
export async function listCmsProductComment(params?: CmsProductCommentParam) {
  const res = await request.get<ApiResult<CmsProductComment[]>>(
    '/cms/cms-product-comment',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加产品评论
 */
export async function addCmsProductComment(data: CmsProductComment) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-product-comment',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改产品评论
 */
export async function updateCmsProductComment(data: CmsProductComment) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-product-comment',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除产品评论
 */
export async function removeCmsProductComment(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-product-comment/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除产品评论
 */
export async function removeBatchCmsProductComment(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-product-comment/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询产品评论
 */
export async function getCmsProductComment(id: number) {
  const res = await request.get<ApiResult<CmsProductComment>>(
    '/cms/cms-product-comment/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
